function [Xi, SigXi, M] = VCZARnatural2predictive(Phi, SigPhi, m, p, kappa)
% maps the parameter matrices and dsturbance covariance matrix
% from the natural form of VZAR model to the predictive form

% disp('Release version of function VCZARnatural2predictive')
% tot = sum(Phi,3);
Xi = zeros(m, m, p);
% first generate scaled versions of Xi coeff
if p>1
    Xi(:,:,p) = Phi(:,:,p);
end
if p>2
    for i = (p-1):-1:2
        Xi(:,:,i) = Phi(:,:,i) - Xi(:,:,i+1);
    end
end
M=eye(m)+Phi(:,:,1);
if p>1
    M=M-Xi(:,:,2);
end
A=inv(M);
S=2*kappa*A;
Xi(:,:,1)=kappa*(eye(m)-2*A);
if p>1
    for i = 2:p
        Xi(:,:,i) = S*Xi(:,:,i);
    end
end

SigXi = A*SigPhi*A';

% disp('in C2D')