function [Phi, SigPhi, M] = VCZARpredictive2natural(Xi, SigXi, m, p, kappa)
% maps the parameter matrices and disturbance covariance matrix
% from the predictive form of VZAR model to the natural form

% disp('Release version of function VCZARpreditive2natural')
Phi = zeros(m, m, p);
F = inv(kappa*eye(m) - Xi(:,:,1));
M=2*kappa*F;

Phi(:,:,1) =  kappa*eye(m) + Xi(:,:,1);
if p>1
    Phi(:,:,1)=Phi(:,:,1)+ Xi(:,:,2);
    Phi(:,:,p) = F*Xi(:,:,p);
end
Phi(:,:,1)=F*Phi(:,:,1);
if p>2
    for i = 2:p-1
        Phi(:,:,i) =  F*(Xi(:,:,i) + Xi(:,:,i+1));
    end
end
SigPhi =  M*SigXi*M';
return
