function [V,E,d,QVit,stab,eqcrit]=eigsort(A,Q)
% calculates eigen quantities needed for state prediction
% when eigenvalues of the transition matrix A are unequal.
% Q is the right factor of the variance matrix of the state disturbance.
% The returned quantity V is the matrix of eigenvectors of A and d the 
% vector of eigenvalues, with columns of V and elements of d sorted 
% for increasing real part of the elements of d. 

% disp('Release version of eigsort')
condlim=0.00001;
[m,n]=size(Q);
[V,D]=eig(A);
E=zeros(n);
QVit=Q;
d=diag(D);
stab=0;
if max(real(d))>0
    stab=1;
    eqcrit=0;
    return
end
mrd=mean(real(d));
[null,Isort]=sort(real(d));
d=d(Isort);
V=V(:,Isort);
E=d*ones(1,n);
eqcrit=min(min(abs((E-conj(E')-eye(n)))))/abs(mrd);
if eqcrit<condlim
    QVit=Q;
    return
end
E=E+E';
QVit=Q/V';
return