function [L,C]=hhrv(F)
% forms reflection vector L of householder transformation that maps F to [C;zeros]
d=length(F);
a=F(1);
s=(2*(a>0)-1);
b=F(2:d);
h=sqrt(F'*F);
if h==0
    L=zeros(d,1);
    L(1)=1;
    C=0;
else
    r=sqrt((1+a*s/h)/2);
    L=[r*s;b/(2*r*h)];
    C=-h*s;
end
return
