function[pcoef,qfactor,qrank]=pnformT(q)
% forms Pade coefficients, determines the coefficients, factor and rank of
% the quadratic form in the quadrature approximation to the square root
% innovation variance matrix

% disp('Release version of pnformT')
% Construct the Pade approximation coefficients
pcoef=zeros(1,q);
pcoef(1)=0.5;
for k=2:q
    pcoef(k)=pcoef(k-1)*(q-k+1) / (k*(2*q-k+1));
end

N=zeros(q); % This is the matrix of the full quadratic form
% Construct the variance matrix approximation coefficients
for r=0:q-1
    for s=r:2:q-1
        Nsum=0;
        for k=1+max(r,s):min(r+s+1,q)
            ck=1; if k>0; ck=pcoef(k); end
            el=r+s-k+1;
            cel=1; if el>0; cel=pcoef(el); end
            Nsum=Nsum+ck*cel*(-1)^(s+k+1);
        end
        N(r+1,s+1)=2*Nsum;
        N(s+1,r+1)=2*Nsum;
    end
end
% Factor the coefficient matrix
qfactor=chol(N);
qrank=q;

return
