function [TscPow,GTtscPow,scale]=powscalT(T,cholG,q)
% Used in the Pade approximations of order q
% obtains scaling factor for T, powers of scaled T,
% and products of cholG with powers of scaled T'

% disp('Release version of powscalT')
bnd=0.4; % bound on scaled  norm for good Pade approximation
[m,n]=size(cholG);
maxeig=max(abs(eig(T)));
if maxeig==0
    scale=1;
else
    scale=maxeig/bnd;
end
Tsc=T/scale;
Tsct=Tsc';
TscPow=zeros(n,n,q);
TscPow(:,:,1)=Tsc;
for k=2:q
    TscPow(:,:,k)= Tsc*TscPow(:,:,k-1);
end
GTtscPow=zeros(m,n,q);
GTtscPow(:,:,1)=cholG*Tsct;
for k=2:q
    GTtscPow(:,:,k)=GTtscPow(:,:,k-1)*Tsct;
end
return