function [y,e,X,Z,scFail,stab,DSig,NSig]=scoreconstruct(yRef,m,p,kappa,obsnoise,xreg,xregnum,...
    subindex,lensubpar,parvec,parind,struc,pertscale,stanperr,predsdev,delta)
% constructs numerical derivatives X, Z of residuals and their se's for active parameters
% evaluated at current parameter values
% also saves modified responses Y, e for parameter correction estimation

% disp('Release version of scoreconstruct')
nact=lensubpar;
lenerr=length(stanperr);
perr=stanperr.*predsdev; % true prediction error
y=stanperr;
e=perr;
X=zeros(lenerr,lensubpar);
Y=zeros(lenerr,lensubpar);
for i = 1:nact
    parvecpert=parvec;
    j=subindex(i);
    %     disp(['perturbation indices',sprintf('\t%0.6g',i,j)])
    deltascale=delta*pertscale(j);
    parvecpert(j)=parvec(j)+deltascale;
    [stanperrpert,predsdevpert,dev,stab,DSig,NSig] = ...
        VCZARlikfun(yRef,m,p,kappa,obsnoise,xreg,xregnum,parvecpert,parind,struc);
    if (stab+DSig+NSig)>0
        stab=0;DSig=0;NSig=0;
        deltascale=-deltascale;
        parvecpert(j)=parvec(j)+deltascale;
%         disp('parameter perturbation reversed')
        [stanperrpert,predsdevpert,dev,stab,DSig,NSig] = ...
            VCZARlikfun(yRef,m,p,kappa,obsnoise,xreg,xregnum,parvecpert,parind,struc);
    end
    scFail=0;
    if (stab+DSig+NSig)>0
        disp('model invalid when parameters perturbed')
        scFail=1;
    else
        perrpert=stanperrpert.*predsdevpert;
        X(:,i)=((perrpert-perr)/deltascale)./predsdev;
        Z(:,i)=((predsdevpert-predsdev)/deltascale)./predsdev;
    end
end
return
