function [newsubparvec,newstanperr,newpredsdev,newdev,Iprogress,newlam]=...
    search(y,e,X,Z,subindex,lensubpar,oldparvec,parind,struc,olddev,oldlam,...
    yRef,m,p,kappa,obsnoise,xreg,xregnum,controlpar)
%
% attempts to find a new set of parameter values with improved deviance

Nobs=length(y);
w=ones(Nobs,1);
E=zeros(lensubpar,1);
xregtot=sum(xregnum);
facup=controlpar(4);
facdn=controlpar(5);
laminit=controlpar(6);
lamlow=controlpar(7);
lammax=controlpar(8);
maxinner=controlpar(10);
eps=controlpar(11);
newparvec=oldparvec;
oldsubparvec=oldparvec(subindex);
sqrt2=sqrt(2);
d=sqrt(sum([X;sqrt2*Z].^2)); % used to scale search constraint
D=diag(d);
lam=0.0; % experiment with resetting lam each time
% lam=oldlam;
Failind6=0; % initialise indicator of constraint parameter exceedence
for inn=1:maxinner % loop of constrained search
%     disp(['lam in search',sprintf('\t%0.10g',lam)])
    lamold=lam;
%     inn
%     lamold
    Failind1=0; % initialise indicator of equations non-singular
    Failind2=0; % initialise indicator of VCZARsig non-positive
    Failind3=0; % initialise indicator of NoiseSig matrix non-positive
    Failind4=0; % initialise indicator of new model stability
    Failind5=1; % initialise indicator of Deviance non-reduction
    [Q,R]=qr([X;sqrt2*Z;lam*D],0); % to solve for parameter corrections
    r=diag(R);
    if min(abs(r./d'))<eps
        Failind1=1
    else
        delsubparvec = R\(Q'*[y;(w-y.^2)/sqrt2;E]);
%         disp('delsubparvec in search')
%         delsubparvec
        newsubparvec=oldsubparvec-delsubparvec;
        newparvec(subindex)=newsubparvec;
%         disp('newparvec in search')
%         newparvec
        [newVCZARcoeff,newVCZARSig,newNoiseSig,newxregcoeff]=...
            parvec2true(newparvec,m,p,obsnoise,xregtot,struc);
        
        if struc==0
            [Rch,posch]=chol(newVCZARSig);
            Failind2=(posch>0); % indicates not positive definite
        else
            Failind2=(min(diag(newVCZARSig))<0);
        end
        if obsnoise==1
            Failind3=(min(newNoiseSig)<0); % not positive definite
        end
        if obsnoise==2
            [Rchn,posch]=chol(newNoiseSig);
            Failind3=(posch>0); % indicates not positive definite
        end
        %evaluate new model
        if (Failind2+Failind3+Failind4)==0
            [newstanperr,newpredsdev,newdev,stab,DSig,NSig] =...
                VCZARlikfun(yRef,m,p,kappa,obsnoise,xreg,xregnum,newparvec,parind,struc);
            Failind4=stab;
%             disp(['Deviance in search',sprintf('\t%0.10g',newdev)])
            if Failind4==0
                Failind5=(newdev>olddev);
            end
        end
    end
    % Next check progress of search
    if (Failind1+Failind2+Failind3+Failind4+Failind5)>0
        if lam<lamlow
            lam=max(laminit,lamold);
        else
            lam=lam*facup;
        end
    else
        lam=lam/facdn;
        if lam<lamlow
            lam=0.0;
        end
        break % from inner constrained loop because of successful step
    end
    if lam>lammax
        Failind6=1;
        break % from inner constrained loop because of failure to progress
    end
end
newlam=lam;
Iprogress=[Failind1,Failind2,Failind3,Failind4,Failind5,Failind6];
if sum(Iprogress)>0 % define null results of search fails
    newsubparvec=[];
    newstanperr=[];
    newpredsdev=[];
    newdev=[];
end
